--- software/crash_handling/CrashHandling.cpp.orig	2013-11-19 10:45:17.000000000 +0100
+++ software/crash_handling/CrashHandling.cpp	2014-02-06 14:02:03.000000000 +0100
@@ -38,12 +38,14 @@
 /*
   Linux/MacOS-specific handling
  */
-#if defined(__linux) || defined(__APPLE__)
+#if defined(__linux) || defined(__APPLE__) || defined(__FreeBSD__)
 
 #include "UnixSignalInterposer.h"
 
 #if defined(__APPLE__)
 #include <sys/ucontext.h>
+#elif defined(__FreeBSD__)
+#include <ucontext.h>
 #else
 
 // This structure mirrors the one found in /usr/include/asm/ucontext.h
@@ -60,8 +62,16 @@
 void dumpStack(int sig, siginfo_t *, void * ucontext) {
 
   // Get the address at the time the signal was raised from the EIP (x86) or RIP (x86_64)
+#ifdef __FreeBSD__ 
+    ucontext_t * uc = reinterpret_cast<ucontext_t *>(ucontext);
 
-#ifndef __APPLE__
+# if defined(__i386)
+    void *callerAddress = reinterpret_cast<void *>(uc->uc_mcontext.mc_eip); // x86 specific
+# else
+    void *callerAddress = reinterpret_cast<void *>(uc->uc_mcontext.mc_rip); // x86_64 specific
+#endif
+
+#elif !defined(__APPLE__)
 
   sig_ucontext_t * uc = reinterpret_cast<sig_ucontext_t *>(ucontext);
 # if defined(__i386__)
